#include "stdafx.h"
#include "MFC_ODBC.h"
#include "Dlg.h"

Dlg::Dlg(CWnd* pParent):CDialog(Dlg::IDD, pParent){
	m_hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);}

void Dlg::DoDataExchange(CDataExchange* pDX){
	CDialog::DoDataExchange(pDX);}

BEGIN_MESSAGE_MAP(Dlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_BN_CLICKED(Down, Down_onClick)
	ON_BN_CLICKED(Up, Up_onClick)
	ON_WM_CLOSE()
	ON_BN_CLICKED(Radio1,Radio1_onCheck)
	ON_BN_CLICKED(Radio2,Radio2_onCheck)
	ON_BN_CLICKED(Radio3,Radio3_onCheck)
	ON_BN_CLICKED(AButton,AButton_onClick)
	ON_BN_CLICKED(EButton,EButton_onClick)
	ON_BN_CLICKED(DButton,DButton_onClick)
	ON_BN_CLICKED(Sort1,Sort1_onClick)
	ON_BN_CLICKED(Sort2,Sort2_onClick)
	ON_BN_CLICKED(Sort3,Sort3_onClick)
	ON_BN_CLICKED(Sort4,Sort4_onClick)
END_MESSAGE_MAP()

void Dlg::OnPaint() {
	if(IsIconic())	{
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND,(WPARAM) dc.GetSafeHdc(),0);
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;
		dc.DrawIcon(x, y, m_hIcon);}
	else{
		CDialog::OnPaint();}}

HCURSOR Dlg::OnQueryDragIcon(){
	return (HCURSOR) m_hIcon;}

int Dlg::OnCreate(LPCREATESTRUCT lpCreateStruct){
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;	
	return 0;}

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

#include "Tables/jobs.h"

	CDatabase DB;
	CJobs Jobs(&DB);
	CEdit* pEdit1;
	CEdit* pEdit2;
	CEdit* pEdit3;
	CEdit* pEdit4;
	CEdit* pAButton;
	CEdit* pEButton;
	CEdit* pDButton;
	CButton* pUp;
	CButton* pDown;
	CButton* pSort1;
	CButton* pSort2;
	CButton* pSort3;
	CButton* pSort4;
	bool isSort1=0;
	bool isSort2=0;
	bool isSort3=0;
	bool isSort4=0;
	
	void fields_Preview();

char buf[10]; char* toString(int value,int radix=10){
	itoa(value,buf,radix);
	return buf;};

void Dlg::OnClose(){
	Jobs.Close();
	DB.Close();
	CDialog::OnClose();}

BOOL Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	pEdit1=(CEdit*)GetDlgItem(Edit1);
	pEdit2=(CEdit*)GetDlgItem(Edit2);
	pEdit3=(CEdit*)GetDlgItem(Edit3);
	pEdit4=(CEdit*)GetDlgItem(Edit4);
	pAButton=(CEdit*)GetDlgItem(AButton);
	pEButton=(CEdit*)GetDlgItem(EButton);
	pDButton=(CEdit*)GetDlgItem(DButton);
	pUp=(CButton*)GetDlgItem(Up);
	pDown=(CButton*)GetDlgItem(Down);
	pSort1=(CButton*)GetDlgItem(Sort1);
	pSort2=(CButton*)GetDlgItem(Sort2);
	pSort3=(CButton*)GetDlgItem(Sort3);
	pSort4=(CButton*)GetDlgItem(Sort4);

	Radio2_onCheck();
	((CButton*)GetDlgItem(Radio2))->SetCheck(true);
		
	try{
	    DB.Open("ODBC;DSN=");
		Jobs.Open(AFX_DB_USE_DEFAULT_TYPE,"Jobs");
		Jobs.MoveFirst();
		fields_Preview();
	}
	catch(CDBException *pError){
	//	CString str;
	//	str+=pError->m_strStateNativeOrigin; str+="\n"; str+=pError->m_strError;
	//	AfxMessageBox(str);
	//	pError->Delete();
		};
	
	return TRUE;
}

void Dlg::Up_onClick(){
	if(Jobs.IsBOF()) return;
	Jobs.MovePrev();
	fields_Preview();}

void Dlg::Down_onClick(){
	if(Jobs.IsEOF()) return;
	Jobs.MoveNext();
	fields_Preview();}

void fields_Preview(){
	pEdit1->SetWindowText(toString(Jobs.m_Job_ID));
	pEdit2->SetWindowText(toString(Jobs.m_min_lvl));
	pEdit3->SetWindowText(toString(Jobs.m_man_lvl));
	pEdit4->SetWindowText(Jobs.m_description);};

void fields_Clear(){
	pEdit1->SetWindowText("");
	pEdit2->SetWindowText("");
	pEdit3->SetWindowText("");
	pEdit4->SetWindowText("");};

void setUpDownMode(int mode){
	pUp->EnableWindow(mode);
	pDown->EnableWindow(mode);}

void readOnlyWhenDelete(int mode){
	pEdit2->SetReadOnly(mode);
	pEdit3->SetReadOnly(mode);
	pEdit4->SetReadOnly(mode);}

void SelectMode(int c1,int c2,int c3){
	pAButton->EnableWindow(c1);
	pEButton->EnableWindow(c2);
	pDButton->EnableWindow(c3);}

void Dlg::Radio1_onCheck(){
	setUpDownMode(0);
	readOnlyWhenDelete(0);
	fields_Clear();
	SelectMode(1,0,0);}

void Dlg::Radio2_onCheck(){
	setUpDownMode(1);
	readOnlyWhenDelete(0);
	fields_Preview();
	SelectMode(0,1,0);}

void Dlg::Radio3_onCheck(){
	setUpDownMode(1);
	readOnlyWhenDelete(1);
	fields_Preview();
	SelectMode(0,0,1);}


void reloadAfterSort(){
	CString res;
	res+=(isSort1?"Job_ID,":"");
	res+=(isSort2?"min_lvl,":"");
	res+=(isSort3?"man_lvl,":"");
	res+=(isSort4?"description,":"");
	Jobs.m_strSort=res.Left(res.GetLength()-1);
	Jobs.Requery();
	fields_Preview();}

void Dlg::Sort1_onClick(){;
	isSort1=pSort1->GetCheck();
	reloadAfterSort();}

void Dlg::Sort2_onClick(){
	isSort2=pSort2->GetCheck();
	reloadAfterSort();}

void Dlg::Sort3_onClick(){
	isSort3=pSort3->GetCheck();
	reloadAfterSort();}

void Dlg::Sort4_onClick(){
	isSort4=pSort4->GetCheck();
	reloadAfterSort();}

void Dlg::AButton_onClick(){
	CString buf;
	Jobs.AddNew();
		pEdit2->GetWindowText(buf); Jobs.m_min_lvl=atoi(buf);
		pEdit3->GetWindowText(buf); Jobs.m_man_lvl=atoi(buf);
		pEdit4->GetWindowText(buf); Jobs.m_description=buf;
	Jobs.Update();
	Jobs.Requery();
	Jobs.MoveLast();
	fields_Clear();}

void Dlg::EButton_onClick(){
	CString buf;
	Jobs.Edit();
		pEdit2->GetWindowText(buf); Jobs.m_min_lvl=atoi(buf);
		pEdit3->GetWindowText(buf); Jobs.m_man_lvl=atoi(buf);
		pEdit4->GetWindowText(buf); Jobs.m_description=buf;
	Jobs.Update();}

void Dlg::DButton_onClick(){
	CString buf;
	pEdit1->GetWindowText(buf);
	fields_Clear();
	if(buf!=""){
		CString sql="DELETE Jobs.* FROM Jobs WHERE Job_ID=";
		sql+=buf;
		DB.ExecuteSQL(sql);
	 // ---
		Jobs.Requery();
		fields_Preview();}}

/*
  	CButton* pRadio1=(CButton*)GetDlgItem(Radio1);
	int status=pRadio1->GetCheck();
	AfxMessageBox(toString(status));
*/
